!include "FileFunc.nsh"
!include "wersja.nsi"

!define FIRMA      "Anlero"
!define PROGRAM    "Nova Sgis 2008 OBD"
!define INST       "${FIRMA}\${PROGRAM}"
!define ST_MENU    "${FIRMA}\${PROGRAM}"
!define USB_DRV    1
!define PROG_DIR   ${FIRMA}

Icon ${PROG_DIR}\ikona.ico

Var InstallUSBDriversQuestion

!if ${USB_DRV} == 1
    Name    "${FIRMA} ${PROGRAM} ${WERSJA} and USB drivers"
    OutFile "000.release\${FIRMA} ${PROGRAM} ${WERSJA} and USB drivers.exe"
!else
    Name    "${FIRMA} ${PROGRAM} ${WERSJA}"
    OutFile "000.release\${FIRMA} ${PROGRAM} ${WERSJA}.exe"
!endif

InstallDir       "$PROGRAMFILES\${INST}"
InstallDirRegKey HKLM "SOFTWARE\${FIRMA}\${PROGRAM}" "Install_Dir"

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Afrikaans.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Albanian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Arabic.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Basque.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Belarusian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Bosnian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Breton.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Bulgarian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Catalan.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Croatian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Czech.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Danish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Dutch.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Estonian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Farsi.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Finnish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\French.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Galician.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\German.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Greek.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Hebrew.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Hungarian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Icelandic.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Indonesian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Irish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Italian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Japanese.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Korean.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Kurdish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Latvian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Lithuanian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Luxembourgish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Macedonian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Malay.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Mongolian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Norwegian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\NorwegianNynorsk.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Polish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Portuguese.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\PortugueseBR.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Romanian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Russian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Serbian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\SerbianLatin.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\SimpChinese.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Slovak.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Slovenian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Spanish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\SpanishInternational.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Swedish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Thai.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\TradChinese.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Turkish.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Ukrainian.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Uzbek.nlf"
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\Welsh.nlf"

;--------------------------
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------

Function .onInit
	;Language selection dialog
	Push ""       
	Push ${LANG_ENGLISH}
	Push English
	;Push ${LANG_SPANISH}
	;Push Spanish
    Push ${LANG_GERMAN}
    Push German
	Push ${LANG_POLISH}
	Push Polish
	;Push ${LANG_PORTUGUESE}
	;Push Portuguese
	Push ${LANG_RUSSIAN}
	Push Russian
	Push ${LANG_ROMANIAN}
	Push Romanian
    Push ${LANG_THAI}
    Push Thai
	;Push ${LANG_UKRAINIAN}
	;Push Ukrainian
	Push A ; A means auto count languages
	       ; for the auto count to work the first empty push (Push "") must remain
	LangDLL::LangDialog "Installer Language" "Please select the language of the installer"

	Pop $LANGUAGE
	StrCmp $LANGUAGE "cancel" 0 +2
		Abort
FunctionEnd

Section ""
    RMDir /r "$INSTDIR"
    CreateDirectory "$INSTDIR"
	SetOutPath $INSTDIR
	File "${PROG_DIR}\minisec.exe"
	File "${PROG_DIR}\wzorcowy_minisec.ecu"
    File "${PROG_DIR}\wzorcowy_sec.ecu"
    File "${PROG_DIR}\ikona.ico"

    Rename "minisec.exe" "${PROGRAM}.exe"

	CreateDirectory "$INSTDIR\localization"
    CreateDirectory "$INSTDIR\eeprom"
    CreateDirectory "$INSTDIR\schemat"

    SetOutPath "$INSTDIR\schemat"
    File "003.schemat\schemat_mini_eng.pdf"

	SetOutPath "$INSTDIR\localization"
	File "002.localization\angielski.txt"
	File "002.localization\angielski.obd.txt"
	File "002.localization\niemiecki.txt"
	File "002.localization\niemiecki.obd.txt"
	File "002.localization\polski.txt"
    File "002.localization\polski.obd.txt"
	File "002.localization\rosyjski.txt"
	File "002.localization\rosyjski.obd.txt"
    File "002.localization\tajski.txt"
    File "002.localization\tajski.obd.txt"
	File "002.localization\_anlero.rumunski.txt"
	File "002.localization\_anlero.rumunski.obd.txt"

!if ${USB_DRV} == 1
    CreateDirectory "$INSTDIR\usb"
    SetOutPath      "$INSTDIR\usb"
    File            "usb_drivers.exe"
!endif

	SetOutPath $INSTDIR
SectionEnd

Section "Section number two"
    CreateDirectory "$APPDATA\${FIRMA}"
    CreateDirectory "$APPDATA\${FIRMA}\${PROGRAM}"
    FileOpen      $0 "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" a
    IfErrors 0 +2
        FileOpen  $0 "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" w
    FileClose     $0
	FileOpen      $0 "$INSTDIR\app.ini" a
    IfErrors 0 +2
        FileOpen  $0 "$INSTDIR\app.ini" w
	FileClose     $0

	StrCmp $LANGUAGE ${LANG_ENGLISH} 0 +4
	    WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "angielski"
	    WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "angielski"
        StrCpy $InstallUSBDriversQuestion "Install USB drivers?"
    StrCmp $LANGUAGE ${LANG_GERMAN} 0 +4
        WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "niemiecki"
        WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "niemiecki"
        StrCpy $InstallUSBDriversQuestion "USB Treiber installieren?"
	StrCmp $LANGUAGE ${LANG_POLISH} 0 +4
	    WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "polski"
	    WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "polski"
        StrCpy $InstallUSBDriversQuestion "Czy zainstalowa sterowniki USB?"
	StrCmp $LANGUAGE ${LANG_RUSSIAN} 0 +4
	    WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "rosyjski"
	    WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "rosyjski"
        StrCpy $InstallUSBDriversQuestion "Install USB drivers?"
	StrCmp $LANGUAGE ${LANG_ROMANIAN} 0 +4
	    WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "_anlero.rumunski"
	    WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "_anlero.rumunski"
        StrCpy $InstallUSBDriversQuestion "Install USB drivers?"
    StrCmp $LANGUAGE ${LANG_THAI} 0 +4
        WriteINIStr "$APPDATA\${FIRMA}\${PROGRAM}\app.ini" "Settings" "Language" "tajski"
        WriteINIStr "$INSTDIR\app.ini"                     "Settings" "Language" "tajski"
        StrCpy $InstallUSBDriversQuestion "Install USB drivers?"

    FlushINI "$APPDATA\${FIRMA}\${PROGRAM}\app.ini"
    FlushINI "$INSTDIR\app.ini"
SectionEnd

Section "Start Menu Shortcuts"
    CreateDirectory "$SMPROGRAMS\${ST_MENU}"
    CreateShortCut  "$DESKTOP\${PROGRAM}.lnk"               "$INSTDIR\${PROGRAM}.exe"      "" "$INSTDIR\ikona.ico"           0
    CreateShortCut  "$SMPROGRAMS\${ST_MENU}\Uninstall.lnk"  "$INSTDIR\uninstall.exe"       "" "$INSTDIR\uninstall.exe"       0
    CreateShortCut  "$SMPROGRAMS\${ST_MENU}\${PROGRAM}.lnk" "$INSTDIR\${PROGRAM}.exe"      "" "$INSTDIR\ikona.ico"           0
!if ${USB_DRV} == 1
    CreateShortCut  "$SMPROGRAMS\${ST_MENU}\usb.lnk"        "$INSTDIR\usb\usb_drivers.exe" "" "$INSTDIR\usb\usb_drivers.exe" 0
!endif

!if ${USB_DRV} == 1
    MessageBox MB_YESNO $InstallUSBDriversQuestion IDNO +2
        ExecShell "open" "$SMPROGRAMS\${ST_MENU}\usb.lnk"
!endif

SectionEnd

; The stuff to install

Section "Example2 (required)"
    SectionIn RO
    ; Set output path to the installation directory.
    SetOutPath $INSTDIR
    ; Put file there
    File "Anlero.nsi"
    ; Write the installation path into the registry
    WriteRegStr HKLM "SOFTWARE\${FIRMA}\${PROGRAM}" "Install_Dir" "$INSTDIR"
    ; Write the uninstall keys for Windows
    WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${FIRMA}\${PROGRAM}" "DisplayName"     "${FIRMA}\${PROGRAM}"
    WriteRegStr   HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${FIRMA}\${PROGRAM}" "UninstallString" '"$INSTDIR\uninstall.exe"'
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${FIRMA}\${PROGRAM}" "NoModify"        1
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${FIRMA}\${PROGRAM}" "NoRepair"        1

    WriteUninstaller "uninstall.exe"
SectionEnd

Section "Uninstall"
    ; Remove registry keys
    DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${FIRMA}\${PROGRAM}"
    DeleteRegKey HKLM "SOFTWARE\${FIRMA}\${PROGRAM}"

    ; Remove files and uninstaller
    Delete $INSTDIR\*.*

    ; Remove shortcuts, if any
    Delete "$DESKTOP\${PROGRAM}.lnk"

    ; Remove directories used
    RMDir /r "$SMPROGRAMS\${ST_MENU}"
    RMDir /r "$INSTDIR"
SectionEnd
